/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mact_tsk2.c 308 2009-07-08 03:19:04Z ertl-honda $
 */

/* 
 *		mact_tskӥΥƥ(2)
 *  ڥƥȤŪ
 *    оݥٻ߾֤ΥФơmact_tskȯԤ롥
 *    ¾ץå˳դ줿򼫥ץåذưѥ
 *    ƥȤ롥
 *
 *  ڥƥȹܡ
 *    ưCPUΥǥ塼Ǥΰ֤ˤʬԤ
 *
 *    (2-E) ǹͥ
 *    (2-F) ¹Ծ֤ΥƱͥ
 *    (2-G) ¹Ծ֤Υͥ
 */


#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

void
task1_4(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(1);
	ercd = mact_tsk(TASK2_1,1);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ
	do{
		ercd = pol_flg(FLG1,1,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(4);
	ercd = mact_tsk(TASK2_4,1);
	check_ercd(ercd, E_OK);

	check_point(5);
	ercd = mact_tsk(TASK2_7,1);
	check_ercd(ercd, E_OK);

	check_point(6);
	ercd = slp_tsk();
	check_ercd(ercd,E_OK);

	check_point(0);
}

void
task2_1(intptr_t exinf)
{
	ER		ercd;

	check_point(2);
	ercd = set_flg(FLG1,1);
	check_ercd(ercd, E_OK);
  
	check_point(3);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);
  
	check_point(0);
}

void
task2_4(intptr_t exinf)
{
	ER		ercd;

	check_point(7);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task2_7(intptr_t exinf)
{
	act_tsk(TASK2_FINISH);
	check_finish(8);//CPU1
}

void
task2_finish(intptr_t exinf)
{
	check_finish(1);//CPU2
}
